package edu.rice.comp211.laundry.command;

/**
 * Variant class in Command union.   
 * Represents a request to launder up to the maximum number of dirty clothes allowed.
 */
public class Launder extends Command {
   @Override
   public <R> R accept(CommandVisitor<R> c) {
      return c.forLaunder(this);
   }

   @Override
   public String toString() {
      return "launder";
   }
}
