package edu.rice.comp211.laundry.command;

import edu.rice.comp211.laundry.garment.Garment;

/**
 * Variant class in Command union.
 * Represents a request to lose to a garment exactly the same as the given garment.
 */
public class Lose extends Command {
   public final Garment garment;

   public Lose(Garment g) {
      garment = g;
   }

   @Override
   public <R> R accept(CommandVisitor<R> c) {
      return c.forLose(this);
   }

   @Override
   public String toString() {
      return "lose " + garment.toString();
   }
}
