package edu.rice.comp211.laundry.garment;

/**
 * A visitor to a Garment
 * @param <R> the return type of the visitor
 */
public interface GarmentVisitor<R> {
	/**
	 * Shirt case of the visitor
	 * @param s The Shirt host
	 * @return The return value of the visitor
	 */
	R forShirt(Shirt s);

	/**
	 * Pants case of the visitor
	 * @param p The Pants host
	 * @return The return value of the visitor
	 */
	R forPants(Pants p);

	/**
	 * Socks case of the visitor
	 * @param s The Socks host
	 * @return The return value of the visitor
	 */
	R forSocks(Socks s);

	/**
	 * NullGarment case of the visitor
	 * @param ng The NullGarment host
	 * @return The return value of the visitor
	 */
	R forNullGarment(NullGarment ng);
}
