/**
 * 
 */
package edu.rice.comp211.laundry.garment;

/**
 * A visitor to a Garment that returns true if the other garment is the same type as the host, i.e. 
 * Shirt, Pants, Socks or NullGarment.  False is returned otherwise.  The adjective is ignored.
 * @author swong
 *
 */
public class SameTypeGarmentVisitor implements GarmentVisitor<Boolean> {

	/**
	 * The other Garment to compare against.
	 */
	private Garment other;
	
	/**
	 * Constructor for the class
	 * @param other The other Garment to compare against
	 */
	public SameTypeGarmentVisitor(Garment other) {
		this.other = other;
	}

	@Override
	public Boolean forShirt(Shirt s) {
		return other.accept(new AGarmentVisitor<Boolean>(false) {
			public Boolean forShirt(Shirt s) {
				return true;
			}
		});
	}

	@Override
	public Boolean forPants(Pants p) {
		return other.accept(new AGarmentVisitor<Boolean>(false) {
			public Boolean forPants(Pants p) {
				return true;
			}
		});
	}

	@Override
	public Boolean forSocks(Socks s) {
		return other.accept(new AGarmentVisitor<Boolean>(false) {
			public Boolean forSocks(Socks s) {
				return true;
			}
		});
	}

	@Override
	public Boolean forNullGarment(NullGarment g) {
		return other.accept(new AGarmentVisitor<Boolean>(false) {
			public Boolean forNullGarment(NullGarment g) {
				return true;
			}
		});
	}

}
