/* StringOutputStream.java
 * Author: Mohamed Mansour, www.m0interactive.com, created Nov 2006
 * Revised by Shams Imam & Robert Cartwright Apr 2010 */
package edu.rice.comp211.laundry.io;

import java.io.OutputStream;

public class StringOutputStream extends OutputStream {

   /**
    * Buffer containing the stream
    */
   protected StringBuilder buffer = new StringBuilder();

   /**
    * Relying on default constructor
    */

   @Override
   public void close() {
   }

   @Override
   public void flush() {
      buffer.delete(0, buffer.length());
   }  /* Clears the buffer. */

   @Override
   public void write(byte[] b) {
      String str = new String(b);
      buffer.append(str);
   }

   @Override
   public void write(byte[] b, int off, int len) {
      String str = new String(b, off, len);
      buffer.append(str);
   }

   @Override
   public void write(int b) {
      String str = Integer.toString(b);
      buffer.append(str);
   }

   @Override
   public String toString() {
      return buffer.toString();
   }
}

