package edu.rice.comp211.laundry.iterator;

/**
 * An iterator that traverses a collection of elements of type T possibly modifying it.  As the iterator traverses
 * the list, the list behaves as if it is circular with a dummy element between the last and first elements.
 */
public interface IteratorI<T> extends ReadIteratorI<T> {

   /**
    * Destructively inserts the object o immediately before the current item.  If the list is empty, or the cursor
    * is atEnd(), the node is inserted immediately before the dummy node of the list.
    */
   void insert(T o);

   /**
    * Removes the current element e.
    *
    * @return the removed element e.
    * @throws edu.rice.comp211.laundry.iterator.IteratorException
    *          if the cursor is atEnd() (at the dummy element).
    */
   T remove();
}
