package edu.rice.comp211.laundry.list;

import edu.rice.comp211.laundry.iterator.BiIteratorI;

/* 
 * A mutable list that can be scanned in either direction.
 * @param <T> The type of the elements of the list 
 */
public interface BiListI<T> extends ListI<T> {

   /**
    * The inherited newList with a narrowed output type.
    */
   BiListI<T> newList();

   /**
    * Removes the last element l of this list.
    *
    * @return the removed element l
    * @throws BiListException if no such element exists.
    */
   T remRear();

   /**
    * The inherited newIterator method with a narrowed output type.
    */
   BiIteratorI<T> newIterator();
   
   public <R> R accept(BiListIVisitor<T, R> visitor);
}
